/* Base64̃fR[h Copyright(c)1998 by T.Toda */
#include <stdio.h>

#ifdef	MSDOS
#define	OPENMODE	"wb"
#else
#define	OPENMODE	"w"
#endif

int	main(int argc, char **argv, char **envp)
{
	FILE	*fpin, *fpout;
	int	c, i = 0;
	unsigned char	buffer[4];

	if( argc > 3 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs(" [infile [outfile]]\n", stderr);
		return	4;
	}
	if( argc < 2 ){
		fpin = stdin;
	}
	else if(( fpin = fopen(argv[1],"r")) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(argv[1],stderr);
		fputs("'.\n",stderr);
		return	8;
	}
	if( argc < 3 ){
		fpout = stdout;
	}
	else if(( fpout = fopen(argv[2],OPENMODE)) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(argv[2],stderr);
		fputs("'.\n",stderr);
		return	8;
	}

	while(( c = getc(fpin) ) != EOF ){
		if( c >= 'A' && c <= 'Z' ){
			buffer[i++] = c - 'A';
		}
		else if( c >= 'a' && c <= 'z' ){
			buffer[i++] = c + 26 - 'a';
		}
		else if( c >= '0' && c <= '9' ){
			buffer[i++] = c + 52 - '0';
		}
		else if( c == '+' ){
			buffer[i++] = 62;
		}
		else if( c == '/' ){
			buffer[i++] = 63;
		}
		if( i >= 4 || ( i >= 0 && c == '=' )){
			if( i >= 2 )putc( ( buffer[0] << 2 ) | ( buffer[1] >> 4 ), fpout);
			if( i >= 3 )putc( ( buffer[1] << 4 ) | ( buffer[2] >> 2 ), fpout);
			if( i >= 4 )putc( ( buffer[2] << 6 ) | buffer[3], fpout);
			i = 0;
		}
	}
}
