/* Decode MIME-Q encoded text        */
/*  Copyright(c) 1997,2001 by T.Toda */
#include <stdio.h>

int	main(int argc, char **argv, char **envp)
{
	int	c, c1, c2;
	FILE	*fp;

	if( argc > 2 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs("[infile]\n", stderr);
		return	4;
	}

	if( argc != 2 ){
		fp = stdin;
	}
	else if(( fp = fopen(argv[1],"r")) == NULL ){
		fputs("File Open Error.\n",stderr);
		return	8;
	}

	while(( c = getc(fp) ) != EOF ){
		if( c != '=' ){
			putchar(c);
		}
		else{
			c1 = getc(fp);
			if( c1 >= '0' && c1 <= '9' ){
				c = c1 - '0';
			}
			else if( c1 >= 'A' && c1 <= 'F' ){
				c = c1 - 'A' + 10;
			}
			else if( c1 >= 'a' && c1 <= 'f' ){
				c = c1 - 'a' + 10;
			}
			else if( c1 == '\n' ){
				continue;
			}
			else{
				putchar(c1);
				continue;
			}
			c2 = getc(fp);
			if( c2 >= '0' && c2 <= '9' ){
				c *= 16;
				c += c2 - '0';
			}
			else if( c2 >= 'A' && c2 <= 'F' ){
				c *= 16;
				c += c2 - 'A' + 10;
			}
			else if( c2 >= 'a' && c2 <= 'f' ){
				c *= 16;
				c += c2 - 'a' + 10;
			}
			else{
				putchar(c1);
				putchar(c2);
				continue;
			}
			putchar(c);
		}
	}
	return	0;
}
